/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
#define AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct FONTSETTINGS
{
	int leftBorder;
	int topBorder;
	int rightBorder;
	int bottomBorder;

	string name;
	int height;
	int color;

	short charSet;

	bool smooth;
	bool clearType;

	bool bold;
	bool italic;
	bool underline;

	bool shadow;
	int shadowX;
	int shadowY; 
	int shadowcolor;

	bool textoutline;
	int textoutlinecolor;

	int align;
	int vertalign;

	bool noEllipsis;

	string textFadeCFG;
	bool useTextFade;
	int textFadeLeft;
	int textFadeRight;
	int textFadeTop;
	int textFadeBottom;
};  

class ButtonFont  
{
public:

	ButtonFont();
	virtual ~ButtonFont();

	void configure(const string &name);
	void apply(HDC hDC, int x, int y, int width, int height, const string &caption, int buttonType, int buttonType2, bool internalCall = false);
	void applyScroll(HDC hDC, int x, int y, int width, int height, const string &caption, int buttonType, int buttonType2);

	int scrollPosition;

private:

	void applyFade(HDC hDC, int x, int y, int width, int height, const string &caption, int buttonType, int buttonType2);

	int measure(HDC hDC, const string &caption, int buttonType);

	void subconfigure(string type, FONTSETTINGS &workSettings, FONTSETTINGS &defaultSettings);

	void createHandle(FONTSETTINGS processFont, HFONT &hfont);
	void drawOutline(HDC destHDC, RECT tmpr, int align, int vertalign, bool noEllipsis, const string &caption);

	//Scrolling of Hover Tasks
	int scrollPadLength;

	bool specialHover;
	bool specialGrouped;
	bool specialPressed;

	HFONT normalFont;
	HFONT activeFont;
	HFONT minimizedFont;
	HFONT flashingFont;
	HFONT hoverFont;
	HFONT groupFont;
	HFONT pressedFont;

	FONTSETTINGS defaultfont;
	FONTSETTINGS normal;
	FONTSETTINGS active;
	FONTSETTINGS minimized;
	FONTSETTINGS flashing;
	FONTSETTINGS hover;
	FONTSETTINGS group;
	FONTSETTINGS pressed;

	HFONT tmpFont;
};

#endif // !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
